//+------------------------------------------------------------------+
//|                                              MVC_primitive_2.mq5 |
//|                                Copyright 2021, Andrei Novichkov. |
//|                    https://www.mql5.com/en/users/andreifx60/news |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Andrei Novichkov."
#property link      "https://www.mql5.com/en/users/andreifx60/news"

#property version   "1.00"

#property indicator_chart_window

#property indicator_buffers 1
#property indicator_plots   1

#include "View\MVC_View.mqh"
#include "Model\MVC_Model.mqh"

CView* pView;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() {

   pView = new CView();

   IndicatorSetString (INDICATOR_SHORTNAME, "Primitive1");
   IndicatorSetInteger(INDICATOR_DIGITS, _Digits);

   pView.Initialize();
   return INIT_SUCCEEDED;
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]) {
                
   if(rates_total <= 4) return 0;
   
   int limit = rates_total - prev_calculated;
   
   if (limit == 0)        {
   } else if (limit == 1) {
   
      pView.SetData(Prepare(time, open, high, low, close, 1), 1);      
//         lb[1] = Prepare(time, open, high, low, close, 1);

      return(rates_total);

   } else if (limit > 1)  {
   
//      ArrayInitialize(lb, EMPTY_VALUE);
      pView.ResetBuffers();
      
      limit = rates_total - 4;
      for(int i = limit; i >= 1 && !IsStopped(); i--) {
         pView.SetData(Prepare(time, open, high, low, close, i), i);
//         lb[i] = Prepare(time, open, high, low, close, i);
      }
      return(rates_total);
      
   }

      pView.SetData(Prepare(time, open, high, low, close, 0), 0);   
//   lb[0] = Prepare(time, open, high, low, close, 0);

   return(rates_total);
}

void OnDeinit(const int reason) {
   delete pView;
}
//+------------------------------------------------------------------+
