//+------------------------------------------------------------------+
//|                                                 Ea_primitive.mq5 |
//|                                Copyright 2021, Andrei Novichkov. |
//|                    https://www.mql5.com/en/users/andreifx60/news |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Andrei Novichkov."
#property link      "https://www.mql5.com/en/users/andreifx60/news"

#property version   "1.00"

#include "View\EA_View.mqh"
#include "Model\EA_Model.mqh"

datetime dtNow;


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit() {
   
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) {
   InitView();
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick() {
      if (IsNewCandle() ) {
         double o = iOpen(NULL,PERIOD_CURRENT,1); 
         double c = iClose(NULL,PERIOD_CURRENT,1); 
         if (MaySell(o, c) ) EnterSell();
         if (MayBuy(o, c)  ) EnterSell();
      }// if (IsNewCandle() )   
}// void OnTick()

bool IsNewCandle() {
   datetime d = iTime(NULL, PERIOD_CURRENT, 0);
   if (dtNow == -1 || dtNow != d) {
      dtNow = d;
      return true;
   }  
   return false;
}// bool IsNewCandle()



//int GetBuy()     {return iBuy;}
//
//int GetSell()    {return iSell;}
//+------------------------------------------------------------------+
